window.Gleam.initSearch([{"doc":"gextra","title":"gextra","content":"# gextra\n\n[![Package Version](https://img.shields.io/hexpm/v/gextra)](https://hex.pm/packages/gextra)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gextra/)\n\n```sh\ngleam add gextra\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gextra&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"gextra/bool","title":"lazy_map","content":"pub fn lazy_map(\n  condition: Bool,\n  if_cb: fn() -&gt; a,\n  else_cb: fn() -&gt; a,\n) -&gt; a\n Map a boolean value to the result of one of two functions.\n The function corresponding to the boolean value will be called, and the other will not.\n\n ## Example\n\n \n let assert 1 = bool.lazy_map(True, fn() { 1 }, fn() { 2 })\n let assert 2 = bool.lazy_map(False, fn() { 1 }, fn() { 2 })\n \nSynonyms:\ngextra/bool.lazy_map\ngextra/bool lazy_map","url":"gextra/bool.html#lazy_map"},{"doc":"gextra/bool","title":"map","content":"pub fn map(\n  condition cond: Bool,\n  true true: a,\n  false false: a,\n) -&gt; a\n Map a boolean value to one of two values.\n\n ## Example\n\n \n let assert 1 = bool.map(True, 1, 2)\n let assert 2 = bool.map(False, 1, 2)\n \nSynonyms:\ngextra/bool.map\ngextra/bool map","url":"gextra/bool.html#map"},{"doc":"gextra/bool","title":"gextra/bool","content":"","url":"gextra/bool.html"},{"doc":"gextra/function","title":"hole","content":"pub fn hole(func: fn(a, b) -&gt; c, a: a) -&gt; fn(b) -&gt; c\n\nSynonyms:\ngextra/function.hole\ngextra/function hole","url":"gextra/function.html#hole"},{"doc":"gextra/function","title":"hole2","content":"pub fn hole2(func: fn(a, b, c) -&gt; d, a: a) -&gt; fn(b, c) -&gt; d\n\nSynonyms:\ngextra/function.hole2\ngextra/function hole2","url":"gextra/function.html#hole2"},{"doc":"gextra/function","title":"hole3","content":"pub fn hole3(func: fn(a, b, c, d) -&gt; e, a: a) -&gt; fn(b, c, d) -&gt; e\n\nSynonyms:\ngextra/function.hole3\ngextra/function hole3","url":"gextra/function.html#hole3"},{"doc":"gextra/function","title":"hole4","content":"pub fn hole4(\n  func: fn(a, b, c, d, e) -&gt; f,\n  a: a,\n) -&gt; fn(b, c, d, e) -&gt; f\n\nSynonyms:\ngextra/function.hole4\ngextra/function hole4","url":"gextra/function.html#hole4"},{"doc":"gextra/function","title":"hole5","content":"pub fn hole5(\n  func: fn(a, b, c, d, e, f) -&gt; g,\n  a: a,\n) -&gt; fn(b, c, d, e, f) -&gt; g\n\nSynonyms:\ngextra/function.hole5\ngextra/function hole5","url":"gextra/function.html#hole5"},{"doc":"gextra/function","title":"hole6","content":"pub fn hole6(\n  func: fn(a, b, c, d, e, f, g) -&gt; h,\n  a: a,\n) -&gt; fn(b, c, d, e, f, g) -&gt; h\n\nSynonyms:\ngextra/function.hole6\ngextra/function hole6","url":"gextra/function.html#hole6"},{"doc":"gextra/function","title":"hole7","content":"pub fn hole7(\n  func: fn(a, b, c, d, e, f, g, h) -&gt; i,\n  a: a,\n) -&gt; fn(b, c, d, e, f, g, h) -&gt; i\n\nSynonyms:\ngextra/function.hole7\ngextra/function hole7","url":"gextra/function.html#hole7"},{"doc":"gextra/function","title":"hole8","content":"pub fn hole8(\n  func: fn(a, b, c, d, e, f, g, h, i) -&gt; j,\n  a: a,\n) -&gt; fn(b, c, d, e, f, g, h, i) -&gt; j\n\nSynonyms:\ngextra/function.hole8\ngextra/function hole8","url":"gextra/function.html#hole8"},{"doc":"gextra/function","title":"pipe1","content":"pub fn pipe1(func: fn(a, b) -&gt; c, a: a) -&gt; fn(b) -&gt; c\n Allows piping into a two argument function in a use statement.\n\n ## Example\n\n \n fn main() {\n   use n &lt;- 32\n     |&gt; int.div(2)\n     |&gt; pipe(result.map)\n   let assert 16 = n\n }\n \nSynonyms:\ngextra/function.pipe1\ngextra/function pipe1","url":"gextra/function.html#pipe1"},{"doc":"gextra/function","title":"pipe2","content":"pub fn pipe2(func: fn(a, b, c) -&gt; d, a: a, b: b) -&gt; fn(c) -&gt; d\n Allows piping into a three argument function in a use statement.\nSynonyms:\ngextra/function.pipe2\ngextra/function pipe2","url":"gextra/function.html#pipe2"},{"doc":"gextra/function","title":"pipe3","content":"pub fn pipe3(\n  func: fn(a, b, c, d) -&gt; e,\n  a: a,\n  b: b,\n  c: c,\n) -&gt; fn(d) -&gt; e\n Allows piping into a four argument function in a use statement.\nSynonyms:\ngextra/function.pipe3\ngextra/function pipe3","url":"gextra/function.html#pipe3"},{"doc":"gextra/function","title":"pipe4","content":"pub fn pipe4(\n  func: fn(a, b, c, d, e) -&gt; f,\n  a: a,\n  b: b,\n  c: c,\n  d: d,\n) -&gt; fn(e) -&gt; f\n Allows piping into a five argument function in a use statement.\nSynonyms:\ngextra/function.pipe4\ngextra/function pipe4","url":"gextra/function.html#pipe4"},{"doc":"gextra/function","title":"pipe5","content":"pub fn pipe5(\n  func: fn(a, b, c, d, e, f) -&gt; g,\n  a: a,\n  b: b,\n  c: c,\n  d: d,\n  e: e,\n) -&gt; fn(f) -&gt; g\n Allows piping into a six argument function in a use statement.\nSynonyms:\ngextra/function.pipe5\ngextra/function pipe5","url":"gextra/function.html#pipe5"},{"doc":"gextra/function","title":"pipe6","content":"pub fn pipe6(\n  func: fn(a, b, c, d, e, f, g) -&gt; h,\n  a: a,\n  b: b,\n  c: c,\n  d: d,\n  e: e,\n  f: f,\n) -&gt; fn(g) -&gt; h\n Allows piping into a seven argument function in a use statement.\nSynonyms:\ngextra/function.pipe6\ngextra/function pipe6","url":"gextra/function.html#pipe6"},{"doc":"gextra/function","title":"pipe7","content":"pub fn pipe7(\n  func: fn(a, b, c, d, e, f, g, h) -&gt; i,\n  a: a,\n  b: b,\n  c: c,\n  d: d,\n  e: e,\n  f: f,\n  g: g,\n) -&gt; fn(h) -&gt; i\n Allows piping into an eight argument function in a use statement.\nSynonyms:\ngextra/function.pipe7\ngextra/function pipe7","url":"gextra/function.html#pipe7"},{"doc":"gextra/function","title":"pipe8","content":"pub fn pipe8(\n  func: fn(a, b, c, d, e, f, g, h, i) -&gt; j,\n  a: a,\n  b: b,\n  c: c,\n  d: d,\n  e: e,\n  f: f,\n  g: g,\n  h: h,\n) -&gt; fn(i) -&gt; j\n Allows piping into a nine argument function in a use statement.\nSynonyms:\ngextra/function.pipe8\ngextra/function pipe8","url":"gextra/function.html#pipe8"},{"doc":"gextra/function","title":"gextra/function","content":"","url":"gextra/function.html"},{"doc":"gextra/pair","title":"map","content":"pub fn map(pair: #(a, a), map: fn(a) -&gt; b) -&gt; #(b, b)\n Applies the given function to both elements of the pair.\n\n ## Example\n\n \n let p = #(1, 2)\n let assert pair.map(p, fn(x) { x * 2 }) = #(2, 4)\n \nSynonyms:\ngextra/pair.map\ngextra/pair map","url":"gextra/pair.html#map"},{"doc":"gextra/pair","title":"new1","content":"pub fn new1(first: a) -&gt; #(a, Nil)\n Creates a pair with the given value as the first element and `Nil` as the second.\n\n ## Example\n\n \n let assert pair.new1(1) = #(1, Nil)\n \nSynonyms:\ngextra/pair.new1\ngextra/pair new1","url":"gextra/pair.html#new1"},{"doc":"gextra/pair","title":"new2","content":"pub fn new2(second: a) -&gt; #(Nil, a)\n Creates a pair with `Nil` as the first element and the given value as the second.\n\n ## Example\n\n \n let assert pair.new2(1) = #(Nil, 1)\n \nSynonyms:\ngextra/pair.new2\ngextra/pair new2","url":"gextra/pair.html#new2"},{"doc":"gextra/pair","title":"replace_first","content":"pub fn replace_first(pair: #(a, b), first: c) -&gt; #(c, b)\n Creates a new pair with the first element replaced by the given value.\n\n ## Example\n\n \n let p = #(1, 2)\n let assert pair.replace_first(p, 3) = #(3, 2)\n \nSynonyms:\ngextra/pair.replace_first\ngextra/pair replace_first","url":"gextra/pair.html#replace_first"},{"doc":"gextra/pair","title":"replace_second","content":"pub fn replace_second(pair: #(a, b), second: c) -&gt; #(a, c)\n Creates a new pair with the second element replaced by the given value.\n\n ## Example\n\n \n let p = #(1, 2)\n let assert pair.replace_second(p, 3) = #(1, 3)\n \nSynonyms:\ngextra/pair.replace_second\ngextra/pair replace_second","url":"gextra/pair.html#replace_second"},{"doc":"gextra/pair","title":"twin","content":"pub fn twin(value: a) -&gt; #(a, a)\n Creates a pair with the given value as both the first and second elements.\n\n ## Example\n\n \n let assert pair.twin(1) = #(1, 1)\n \nSynonyms:\ngextra/pair.twin\ngextra/pair twin","url":"gextra/pair.html#twin"},{"doc":"gextra/pair","title":"gextra/pair","content":"","url":"gextra/pair.html"},{"doc":"gextra/result","title":"lazy_map_both","content":"pub fn lazy_map_both(\n  over r: Result(a, b),\n  err err: fn(b) -&gt; c,\n  val val: fn(a) -&gt; d,\n) -&gt; Result(d, c)\n Applies one of two functions depending on whether the result is Ok or Error.\n If the result is Ok, the `val` function is applied to the value.\n If the result is Error, the `err` function is applied to the error.\n\n ## Example\n\n \n let assert Ok(0) = lazy_map_both(\n   Ok(1),\n   fn(x) { x + 1 },\n   fn(x) { x - 1 },\n )\n\n let assert Error(2) = lazy_map_both(\n   Error(1),\n   fn(x) { x + 1 },\n   fn(x) { x - 1 },\n )\n \nSynonyms:\ngextra/result.lazy_map_both\ngextra/result lazy_map_both","url":"gextra/result.html#lazy_map_both"},{"doc":"gextra/result","title":"lazy_try_both","content":"pub fn lazy_try_both(\n  over r: Result(a, b),\n  err err: fn(b) -&gt; c,\n  val val: fn(a) -&gt; Result(d, c),\n) -&gt; Result(d, c)\n Applies one of two functions depending on whether the result is Ok or Error.\n If the result is Ok, the `val` function is applied to the value.\n If the result is Error, the `err` function is applied to the error.\n This function differs from `lazy_map_both` in that the `val` function returns a `Result`.\n\n ## Example\n \n let assert Ok(0) = lazy_try_both(\n     Ok(1), \n     fn(a) { a - 1 }, \n     fn(a) { Ok(a + 1) }\n )\n \n let assert Error(2) = lazy_try_both(\n   Error(1),\n   fn(a) { a - 1 },\n   fn(a) { Ok(a + 1)},\n )\n\n \nSynonyms:\ngextra/result.lazy_try_both\ngextra/result lazy_try_both","url":"gextra/result.html#lazy_try_both"},{"doc":"gextra/result","title":"map_both","content":"pub fn map_both(\n  over r: Result(a, b),\n  err err: c,\n  val val: fn(a) -&gt; d,\n) -&gt; Result(d, c)\n Maps a Result to another Result. If Ok, applies a function to the contained value. If Error, uses provided value.\n\n ## Example\n \n use x &lt;- map_both(Ok(1), 2)\n let assert Ok(1) = x\n\n use y &lt;- map_both(Error(1), 2)\n // never reached\n \nSynonyms:\ngextra/result.map_both\ngextra/result map_both","url":"gextra/result.html#map_both"},{"doc":"gextra/result","title":"try_both","content":"pub fn try_both(\n  over r: Result(a, b),\n  err err: c,\n  val val: fn(a) -&gt; Result(d, c),\n) -&gt; Result(d, c)\n If Ok, applies a function to the contained value which returns a result. If Error, uses provided value.\n\n ## Example\n \n use x &lt;- try_both(Ok(1), 2)\n let assert Ok(1) = x\n\n use y &lt;- try_both(Error(1), 2)\n // never reached\n \nSynonyms:\ngextra/result.try_both\ngextra/result try_both","url":"gextra/result.html#try_both"},{"doc":"gextra/result","title":"try_lazy_map_both","content":"pub fn try_lazy_map_both(\n  over r: Result(a, b),\n  err err: fn(b) -&gt; c,\n) -&gt; fn(fn(a) -&gt; Result(d, c)) -&gt; Result(d, c)\n\nSynonyms:\ngextra/result.try_lazy_map_both\ngextra/result try_lazy_map_both","url":"gextra/result.html#try_lazy_map_both"},{"doc":"gextra/result","title":"try_map_both","content":"pub fn try_map_both(\n  over r: Result(a, b),\n  err err: c,\n) -&gt; fn(fn(a) -&gt; Result(d, c)) -&gt; Result(d, c)\n\nSynonyms:\ngextra/result.try_map_both\ngextra/result try_map_both","url":"gextra/result.html#try_map_both"},{"doc":"gextra/result","title":"use_lazy_map_both","content":"pub fn use_lazy_map_both(\n  over r: Result(a, b),\n  err err: fn(b) -&gt; c,\n) -&gt; fn(fn(a) -&gt; d) -&gt; Result(d, c)\n\nSynonyms:\ngextra/result.use_lazy_map_both\ngextra/result use_lazy_map_both","url":"gextra/result.html#use_lazy_map_both"},{"doc":"gextra/result","title":"use_map_both","content":"pub fn use_map_both(\n  over r: Result(a, b),\n  err err: c,\n) -&gt; fn(fn(a) -&gt; d) -&gt; Result(d, c)\n\nSynonyms:\ngextra/result.use_map_both\ngextra/result use_map_both","url":"gextra/result.html#use_map_both"},{"doc":"gextra/result","title":"gextra/result","content":"","url":"gextra/result.html"}]);